#!/usr/bin/env ruby
# coding: ascii-8bit

require 'kconv'

puts '== Big endian'
p bom_be = [0xFE, 0xFF, 0x00, 0x30, 0x30, 0x42, 0x00, 0x31, 0x00, 0x00].pack('C*'); nobom_be = bom_be[2, 999]
p str = bom_be.unpack('n*').pack('U*')
p str.unpack('U*').pack('n*')
p str.unpack('H*')[0]	# "efbbbf 30 e38182"
puts

puts '== Little endian'
p bom_le = [0xFF, 0xFE, 0x30, 0x00, 0x42, 0x30, 0x31, 0x00, 0x00, 0x00].pack('C*')
p str = bom_le.unpack('v*').pack('U*')
p str.unpack('U*').pack('v*')
p str.unpack('H*')[0]	# "efbbbf 30 e38182"
puts

puts '== Convert test'
[bom_be, nobom_be, bom_le].each {|x|
	puts(str = x.unpack(x =~ /^\xFF/ ? 'v*' : 'n*').pack('U*'))
	puts(str.sub(/^\xEF\xBB\xBF/u, '').sub(/[\x00-\x1F]/u, ''))
}
puts

class String
	def to_hex
		self.unpack('H*')[0].upcase
	end
end

puts '== Unicode char list'
(0xA1..0xFE).each {|b1|
	(0xA1..0xFE).each {|b2|
		euc = [b1, b2].pack('C*')
		jis = euc.tojis[3, 2]
		utf8 = euc.encode('utf-8', 'eucjp') rescue next
		utf16 = utf8.encode('utf-16', 'utf-8')[2, 99]
		puts("%s\t%s\t%s\t%s\t%s" % [utf8, jis.to_hex, euc.to_hex, utf16.to_hex, utf8.to_hex])
	}
}

__END__

